unit AT24C32;

{
Copyright (C) 2016 - Ronald Daleske


some procedures in this unit have taken some ideas of the C sources of:

wiringPi from Gordon Henderson
ds1302.c in
https://github.com/nebrius/wiringPi


Licence
=======

 LGPLv2.1 with static linking exception (See COPYING.modifiedLGPL.txt)

}


{$mode objfpc}{$H+}

interface

uses
  Threads,
  Platform,
  i2c_Basic,
  RGPIO;



const
  ADR_AT24C32_WR : Byte = %10100000;  // 50H -> A0H
  ADR_AT24C32_RD : Byte = %10100001;  // 50H -> A1H




procedure AT24C32_Data_Write_one_Byte(RAM_Address : Word; Data_Byte : Byte);
function AT24C32_Data_Read_one_Byte(RAM_Address : Word) : Byte;





implementation






procedure AT24C32_Data_Write_Word_Address(RAM_Address : Word);
var
  byte_high, byte_low : Byte;
  word_temp : Word;
begin

  // Start-Sequenz
  SDA_Clear;
  MicrosecondDelay(5);
  SCL_Clear;
  MicrosecondDelay(5);


  ds_Shift_Out(ADR_AT24C32_WR);


  word_temp:=RAM_Address shr 8;
  byte_high:=word_temp;

  ds_Shift_Out(byte_high);

  word_temp:=RAM_Address and $00FF;
  byte_low:=word_temp;

  ds_Shift_Out(byte_low);

  // Stop-Sequenz
  SCL_Set;
  MicrosecondDelay(5);

  SDA_Set;
  MicrosecondDelay(5);

end; { procedure AT24C32_Data_Write_Word_Address }







procedure AT24C32_Data_Write_one_Byte(RAM_Address : Word; Data_Byte : Byte);
var
  byte_high, byte_low : Byte;
  word_temp : Word;
begin

  // Start-Sequenz
  SDA_Clear;
  MicrosecondDelay(5);
  SCL_Clear;
  MicrosecondDelay(5);

  // I2C Address
  ds_Shift_Out(ADR_AT24C32_WR);

  word_temp:=RAM_Address shr 8;
  byte_high:=word_temp;

  ds_Shift_Out(byte_high);

  word_temp:=RAM_Address and $00FF;
  byte_low:=word_temp;

  ds_Shift_Out(byte_low);

  ds_Shift_Out(Data_Byte);

  // Stop-Sequenz
  SCL_Set;
  MicrosecondDelay(5);

  SDA_Set;
  MicrosecondDelay(5);

end; { procedure AT24C32_Data_Write_one_Byte }







function AT24C32_Data_Read_one_Byte(RAM_Address : Word) : Byte;
var
  ds_data : Byte;
begin


  AT24C32_Data_Write_Word_Address(RAM_Address);


  // Start-Sequenz
  SDA_Clear;
  MicrosecondDelay(5);
  SCL_Clear;
  MicrosecondDelay(5);

  // I2C Address
  ds_Shift_Out(ADR_AT24C32_RD);

  ds_data:=ds_Shift_In_NACK;


  // Stop-Sequenz
  SCL_Set;
  MicrosecondDelay(5);

  SDA_Set;
  MicrosecondDelay(5);

  Result:=ds_data;

end; { function AT24C32_Data_Read_one_Byte }






















end.

