unit i2c_Basic;


{
Copyright (C) 2016 - Ronald Daleske


some procedures in this unit have taken some ideas of the C sources of:

wiringPi from Gordon Henderson
ds1302.c in
https://github.com/nebrius/wiringPi


Licence
=======

 LGPLv2.1 with static linking exception (See COPYING.modifiedLGPL.txt)

}


{$mode objfpc}{$H+}

interface

uses
 // GlobalTypes,
  Platform,
  Threads,
  RGPIO;


{

GPIO2 -> SDA1 / I2C-Daten
GPIO3 -> SCL1 / I2C-Clock

}



procedure SDA_Set;
procedure SCL_Set;
procedure SDA_Clear;
procedure SCL_Clear;
// Read one Byte from Slave, MSB fist, send NACK
function ds_Shift_In_NACK : Byte;
// Read one Byte from Slave, MSB fist, send ACK
function ds_Shift_In_ACK : Byte;
// Write one Byte to Slave, MSB fist
function ds_Shift_Out(ds_data : Byte) : Boolean;





implementation





procedure SDA_Set;
begin
  GPIO2_Set;
end;


procedure SCL_Set;
begin
  GPIO3_Set;
end;


procedure SDA_Clear;
begin
  GPIO2_Clear;
end;


procedure SCL_Clear;
begin
  GPIO3_Clear;
end;



// Read one Byte from Slave, MSB fist, send NACK
function ds_Shift_In_NACK : Byte;
var
  ds_data, ds_couter : Byte;
begin

  // Data as Input
  GPIO_IN_Init(GPIO2);
  MicrosecondDelay(5);

  ds_data:=0;

  for ds_couter:=0 to 7 do begin

    ds_data:=ds_data shl 1;

    if GPIO2_Read then
      ds_data:=ds_data or %00000001;

    SCL_Set;
    MicrosecondDelay(5);

    SCL_Clear;
    MicrosecondDelay(5);

  end; { for ds_couter:=0 to 7 do }

  // Data as Output
  GPIO_OUT_Init(GPIO2);
  SDA_Set;
  MicrosecondDelay(5);

  SCL_Set;
  MicrosecondDelay(5);

  SCL_Clear;
  MicrosecondDelay(5);

  // Data as Output
  SDA_Clear;

  Result:=ds_data;

end; { function ds_Shift_In_NACK }




// Read one Byte from Slave, MSB fist, send ACK
function ds_Shift_In_ACK : Byte;
var
  ds_data, ds_couter : Byte;
begin

  // Data as Input
  GPIO_IN_Init(GPIO2);
  MicrosecondDelay(5);

  ds_data:=0;

  for ds_couter:=0 to 7 do begin

    ds_data:=ds_data shl 1;

    if GPIO2_Read then
      ds_data:=ds_data or %00000001;

    SCL_Set;
    MicrosecondDelay(5);

    SCL_Clear;
    MicrosecondDelay(5);

  end; { for ds_couter:=0 to 7 do }

  // Data as Output
  SDA_Clear;
  GPIO_OUT_Init(GPIO2);
  SDA_Clear;
  MicrosecondDelay(5);

  SCL_Set;
  MicrosecondDelay(5);

  SCL_Clear;
  MicrosecondDelay(5);

  Result:=ds_data;

end; { function ds_Shift_In_NACK }



// Write one Byte to Slave, MSB fist
function ds_Shift_Out(ds_data : Byte) : Boolean;
var
  ds_couter : Byte;
  ds_result : Boolean;
begin

  // Data as Output
  SDA_Clear;
  GPIO_OUT_Init(GPIO2);
  SDA_Clear;
  MicrosecondDelay(5);

  for ds_couter:=0 to 7 do begin

    if (ds_data and %10000000) = 0 then
      SDA_Clear
    else
      SDA_Set;

    ds_data:=ds_data shl 1;

    MicrosecondDelay(5);

    SCL_Set;
    MicrosecondDelay(5);

    SCL_Clear;
    MicrosecondDelay(5);

  end; { for ds_couter:=0 to 7 do }

  // Data as Input
  GPIO_IN_Init(GPIO2);

  MicrosecondDelay(5);

  SCL_Set;
  MicrosecondDelay(5);

  if GPIO2_Read=false then
    ds_result:=true
  else
    ds_result:=false;

  SCL_Clear;
  MicrosecondDelay(5);

  // Data as Output
  SDA_Clear;
  GPIO_OUT_Init(GPIO2);
  SDA_Clear;
  MicrosecondDelay(5);

  Result:=ds_result;

end; { procedure ds_Shift_Out }




end.

